package problem.fdr;

public class FDROperator {
	
	private static int operatorMaxID = 0;
	
	private final String name;
	private final int ID;
	private final FDRPartialState pre;
	private final FDRPartialState eff;
	private final int cost;

	public FDROperator(String name, FDRPartialState pre, FDRPartialState eff, int cost) {
		super();
		this.name = name;
		this.pre = pre;
		this.eff = eff;
		this.cost = cost;
		ID = operatorMaxID++;
	}

	public String getName() {
		return name;
	}

	public FDRPartialState getPre() {
		return pre;
	}

	public FDRPartialState getEff() {
		return eff;
	}

	public int getCost() {
		return cost;
	}
	
	@Override
	public int hashCode() {
		return ID;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		FDROperator other = (FDROperator) obj;
		if (ID != other.ID)
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "FDROperator [name=" + name + ", pre=" + pre + ", eff=" + eff + ", cost=" + cost + "]";
	}
	
}
